Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_transition.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_transition.cpp	(revision 112)
@@ -53,4 +53,5 @@
             reg_EVENT_VAL            [i] = false;
             reg_EVENT_STATE          [i] = EVENT_STATE_OK;
+            reg_EVENT_IS_BRANCH      [i] = true;
           }
       }
@@ -100,4 +101,8 @@
               // Test if state is end
 //               if (end_ok or end_ko)
+              
+              log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * state is STATE_END      : %d",end);
+              log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_BOTTOM (before) : %d",reg_UPT_BOTTOM         [i]);
+
               if (end)
                 {
@@ -108,8 +113,12 @@
                       branchement_log_file [num_thread] 
                         << std::hex
-                        << "0x" << reg_UPDATE_PREDICTION_TABLE [i][bottom]._address_src  << " "
-                        << "0x" << reg_UPDATE_PREDICTION_TABLE [i][bottom]._address_dest << " "
+                        << "0x" << reg_UPDATE_PREDICTION_TABLE [i][bottom]._address_src       << " "
+                        << "0x" << reg_UPDATE_PREDICTION_TABLE [i][bottom]._address_dest      << " "
                         << std::dec
-                        <<         reg_UPDATE_PREDICTION_TABLE [i][bottom]._good_take    << " "
+                        <<         reg_UPDATE_PREDICTION_TABLE [i][bottom]._good_take         << " - "
+                        << "["  << sc_simulation_time() << "] " << " "
+                        <<         reg_UPDATE_PREDICTION_TABLE [i][bottom]._miss_prediction   << " "
+                        <<         reg_UPDATE_PREDICTION_TABLE [i][bottom]._ifetch_prediction << " "
+                        << "("  << (uint32_t)reg_UPDATE_PREDICTION_TABLE [i][bottom]._condition         << ")"
                         << std::endl;
                     }
@@ -128,23 +137,38 @@
 //                   if (bottom = reg_UPT_UPDATE [i])
 //                     reg_UPT_UPDATE [i] = reg_UPT_BOTTOM [i];
-
-                  if (reg_EVENT_VAL [i] and (reg_EVENT_UPT_PTR [i] == bottom))
+                }// @@@
+              
+              log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_BOTTOM (after ) : %d",reg_UPT_BOTTOM         [i]);
+              log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_EVENT_VAL           : %d",reg_EVENT_VAL     [i]);
+              log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_EVENT_UPT_PTR       : %d",reg_EVENT_UPT_PTR [i]);
+              log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_EVENT_UPT_FULL      : %d",reg_EVENT_UPT_FULL[i]);
+
+              if (reg_EVENT_VAL [i] and (reg_EVENT_UPT_PTR [i] == bottom))
+                {
+                  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * END EVENT");
+
+                  if ((reg_EVENT_IS_BRANCH [i] == false) and (reg_EVENT_UPT_FULL [i] == false))
+                    reg_EVENT_STATE[i] = EVENT_STATE_OK;
+
+                  if ((reg_EVENT_IS_BRANCH [i] == true) or (reg_EVENT_UPT_FULL [i] == false))
                     {
-                      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * END EVENT");
-                      
-                      reg_EVENT_VAL  [i] = false;
-                      reg_UPT_TOP    [i] = reg_UPT_TOP_EVENT [i];
-                      reg_UPT_UPDATE [i] = reg_UPT_TOP_EVENT [i];
-                      
-                      if (reg_UPT_BOTTOM [i] != reg_UPT_TOP [i])
-                        reg_UPT_EMPTY [i] = false;
-
-                      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_TOP             : %d",reg_UPT_TOP            [i]);
-                      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_TOP_EVENT       : %d",reg_UPT_TOP_EVENT      [i]);
-                      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_UPDATE          : %d",reg_UPT_UPDATE         [i]);
-                      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_EMPTY           : %d",reg_UPT_EMPTY          [i]);
+                  reg_EVENT_VAL       [i] = false;
+//                reg_EVENT_IS_BRANCH [i] = true;
+                  reg_UPT_TOP         [i] = reg_UPT_TOP_EVENT [i];
+                  reg_UPT_UPDATE      [i] = reg_UPT_TOP_EVENT [i];
+                  
+                  if (reg_UPT_BOTTOM [i] != reg_UPT_TOP [i])
+                    reg_UPT_EMPTY [i] = false;
                     }
 
+                  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_TOP             : %d",reg_UPT_TOP            [i]);
+                  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_TOP_EVENT       : %d",reg_UPT_TOP_EVENT      [i]);
+                  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_UPDATE          : %d",reg_UPT_UPDATE         [i]);
+                  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_EMPTY           : %d",reg_UPT_EMPTY          [i]);
+                
                 }
+              
+              if (end)
+                reg_EVENT_UPT_FULL [i] = false;
             }
 	  }
@@ -245,4 +269,5 @@
                       log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * EVENT [%d] <- EVENT_STATE_UPDATE_CONTEXT (decod - miss - no flush ufpt)",context);
                       reg_EVENT_STATE [context] = EVENT_STATE_UPDATE_CONTEXT;
+//                       reg_EVENT_SOURCE[context] = EVENT_SOURCE_UFPT;
                     }
                   else
@@ -251,9 +276,9 @@
                       reg_EVENT_STATE [context] = EVENT_STATE_MISS_FLUSH_UFPT;
                     }
-                  reg_EVENT_SOURCE          [context] = EVENT_SOURCE_UFPT;
 
                   // Flush UPFT
                   flush_UFPT [context] = true;
 
+                  reg_EVENT_IS_BRANCH       [context] = true;
                   reg_EVENT_DEPTH           [context] = upt_ptr_write;
                   reg_EVENT_ADDRESS_SRC     [context] = address_src; // delay_slot is compute in Context_State
@@ -357,5 +382,5 @@
                   (internal_UPDATE_VAL_WITHOUT_ACK [i] and can_continue [context]))
                 {
-                  Tdepth_t   depth     = internal_UPDATE_DEPTH      [i];
+                  Tdepth_t   depth     = internal_UPDATE_DEPTH [i];
                   
                   log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * UPDATE[%d] - Accepted",i);
@@ -369,13 +394,21 @@
 //                       if (reg_UFPT_UPDATE [context] == reg_UFPT_BOTTOM [context])
                       if ((--reg_UFPT_NB_UPDATE [context])==0)
-                        switch (reg_EVENT_STATE [context])
-                          {
-                          case EVENT_STATE_MISS_FLUSH_UFPT         : reg_EVENT_STATE [context] = EVENT_STATE_UPDATE_CONTEXT; break;
-                            // impossible to have an update on ufpt and reg_upt_update>reg_upt_top
-                          case EVENT_STATE_MISS_FLUSH_UFPT_AND_UPT : reg_EVENT_STATE [context] = EVENT_STATE_MISS_FLUSH_UPT ; break;
-                          case EVENT_STATE_EVENT_FLUSH_UFPT        : reg_EVENT_STATE [context] = EVENT_STATE_OK             ; break;
-                          case EVENT_STATE_EVENT_FLUSH_UFPT_AND_UPT: reg_EVENT_STATE [context] = EVENT_STATE_EVENT_FLUSH_UPT; break;
-                          default : break;
-                          }
+                        {
+                          switch (reg_EVENT_STATE [context])
+                            {
+                            case EVENT_STATE_MISS_FLUSH_UFPT         : 
+                              {
+                                reg_EVENT_STATE [context] = EVENT_STATE_UPDATE_CONTEXT; 
+//                                 reg_EVENT_SOURCE[context] = EVENT_SOURCE_UFPT;
+
+                                break;
+                              }
+                              // impossible to have an update on ufpt and reg_upt_update>reg_upt_top
+                            case EVENT_STATE_MISS_FLUSH_UFPT_AND_UPT : reg_EVENT_STATE [context] = EVENT_STATE_MISS_FLUSH_UPT ; break;
+                            case EVENT_STATE_EVENT_FLUSH_UFPT        : reg_EVENT_STATE [context] = EVENT_STATE_OK             ; break;
+                            case EVENT_STATE_EVENT_FLUSH_UFPT_AND_UPT: reg_EVENT_STATE [context] = EVENT_STATE_EVENT_FLUSH_UPT; break;
+                            default : break;
+                            }
+                        }
                       
                       log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * Update Fetch Prediction Table");
@@ -405,5 +438,7 @@
                     {
                       log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * Update Prediction Table");
-                      
+                      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_UPDATE (before) : %d",reg_UPT_UPDATE [context]);
+                      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_EVENT_STATE         : %s",toString(reg_EVENT_STATE [context]).c_str());
+ 
                       // Change state
 #ifdef DEBUG_TEST 
@@ -430,5 +465,8 @@
 
                       if (ok or ko)
-                        reg_UPDATE_PREDICTION_TABLE [context][depth]._retire_ok = true;
+                        {
+                          reg_UPDATE_PREDICTION_TABLE [context][depth]._retire_ok       = true;
+                          reg_UPDATE_PREDICTION_TABLE [context][depth]._miss_prediction = ko;
+                        }
 
                       // Have an update, test the state to transiste to the good state
@@ -444,6 +482,9 @@
                           reg_UPDATE_PREDICTION_TABLE [context][depth]._state = UPDATE_PREDICTION_STATE_END_KO;
 
-                          reg_EVENT_VAL     [context] = true;
-                          reg_EVENT_UPT_PTR [context] = depth;
+                          reg_EVENT_VAL      [context] = true;
+                          reg_EVENT_UPT_PTR  [context] = depth;
+//                        reg_EVENT_UPT_FULL [context] = 0;
+//                        reg_EVENT_UPT_FULL        [i] = (not reg_UPT_EMPTY [i] and (bottom == reg_UPT_TOP [i]));
+
 
 #ifdef STATISTICS
@@ -473,13 +514,18 @@
                       // Update pointer
                       //  * if update RAS : update pointer is decreaste until it equal at top pointer
+                      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * internal_UPDATE_RAS [%d] : %d",i,internal_UPDATE_RAS [i]);
+                      
                       if (internal_UPDATE_RAS [i])
                         {
                           // if end_event, restart too bottom, else decrease pointer
                           bool end_event  = (reg_UPT_UPDATE [context] == reg_UPT_TOP [context]);
+
+                          log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * end_event               : %d",end_event);
+                          log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * bottom                  : %d",reg_UPT_BOTTOM[context]);
                           
-                          reg_UPT_UPDATE [context] = (end_event)?reg_UPT_BOTTOM[context]:(((depth==0)?_param->_size_upt_queue[context]:depth)-1);
                           if (end_event)
                             {
-//                               reg_UPT_UPDATE [context] = reg_UPT_BOTTOM[context];
+                              reg_UPT_UPDATE [context] = (end_event)?reg_UPT_BOTTOM[context]:(((depth==0)?_param->_size_upt_queue[context]:depth)-1);
+//                            reg_UPT_UPDATE [context] = reg_UPT_BOTTOM[context];
 
                               if (reg_EVENT_STATE [context] == EVENT_STATE_EVENT_FLUSH_UPT)
@@ -488,5 +534,8 @@
                                 }
                               else
-                                reg_EVENT_STATE [context] = EVENT_STATE_UPDATE_CONTEXT;
+                                {
+                                  reg_EVENT_STATE [context] = EVENT_STATE_UPDATE_CONTEXT;
+//                                   reg_EVENT_SOURCE[context] = EVENT_SOURCE_UPT;
+                                }
                             }
                           else
@@ -497,4 +546,6 @@
                       else
                         {
+                          log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * next update");
+                          
                           // increase pointer
                           reg_UPT_UPDATE [context] = (depth+1)%_param->_size_upt_queue[context];
@@ -502,6 +553,9 @@
                       
                       // Free the branch with no accurate ?
-                      if ( (reg_UPDATE_PREDICTION_TABLE [context][depth]._is_accurate == false) and not ko)
+                      if ((reg_UPDATE_PREDICTION_TABLE [context][depth]._is_accurate == false) and not ko)
                         reg_IS_ACCURATE [context] = true;
+
+                      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_UPDATE (after ) : %d",reg_UPT_UPDATE[context]);
+                      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_EVENT_STATE         : %s",toString(reg_EVENT_STATE [context]).c_str());
                     }
                 }
@@ -513,5 +567,4 @@
           reg_UPDATE_PRIORITY = (reg_UPDATE_PRIORITY+1)%_param->_nb_context;
         }
-
 
 	// ===================================================================
@@ -533,7 +586,8 @@
 
 	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * BRANCH_COMPLETE[%d] - Accepted",i);
-	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * context        : %d",context);
-	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * depth          : %d",depth);
-	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * miss           : %d",miss);
+	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * context             : %d",context);
+	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * depth               : %d",depth);
+	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * miss                : %d",miss);
+              log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_EVENT_STATE     : %s",toString(reg_EVENT_STATE [context]).c_str());
 	      
               if (miss)
@@ -546,4 +600,7 @@
                   event_state_t event_state         = reg_EVENT_STATE [context];
                   upt_state_t   event_top           = reg_UPDATE_PREDICTION_TABLE [context][top]._state;
+
+                  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * event_top           : %s",toString(event_top).c_str());
+
                   bool          previous_ufpt_event = ((event_state == EVENT_STATE_MISS_FLUSH_UFPT_AND_UPT ) or
                                                        (event_state == EVENT_STATE_MISS_FLUSH_UFPT         ) or
@@ -551,14 +608,15 @@
                                                        (event_state == EVENT_STATE_EVENT_FLUSH_UFPT        ));
 
-                  bool          previous_upt_event  = ((event_state == EVENT_STATE_MISS_FLUSH_UFPT_AND_UPT ) or
-                                                       (event_state == EVENT_STATE_MISS_FLUSH_UPT          ) or
-                                                       (event_state == EVENT_STATE_EVENT_FLUSH_UFPT_AND_UPT) or
-                                                       (event_state == EVENT_STATE_EVENT_FLUSH_UPT         ) or
-                                                       (event_top   == UPDATE_PREDICTION_STATE_END_KO      ) or
-                                                       (event_top   == UPDATE_PREDICTION_STATE_KO          )
-//                                                   (event_state == EVENT_STATE_WAIT_END_EVENT          ) or
-//                                                   ((event_state == EVENT_STATE_UPDATE_CONTEXT         ) and
-//                                                    (reg_EVENT_SOURCE [context] == EVENT_SOURCE_UPT))
-                                                  );
+                  bool          previous_upt_event  = (false
+                                                       or  (event_state == EVENT_STATE_MISS_FLUSH_UFPT_AND_UPT )
+                                                       or  (event_state == EVENT_STATE_MISS_FLUSH_UPT          )
+                                                       or  (event_state == EVENT_STATE_EVENT_FLUSH_UFPT_AND_UPT)
+                                                       or  (event_state == EVENT_STATE_EVENT_FLUSH_UPT         )
+                                                       or  (event_top   == UPDATE_PREDICTION_STATE_END_KO      )
+                                                       or  (event_top   == UPDATE_PREDICTION_STATE_KO          )
+//                                                     or  (event_state == EVENT_STATE_WAIT_END_EVENT          )
+//                                                        or ((event_state == EVENT_STATE_UPDATE_CONTEXT          )
+//                                                            and (reg_EVENT_SOURCE [context] == EVENT_SOURCE_UPT))
+                                                       );
 //                bool          update_ras     = (new_update != depth);
 
@@ -568,8 +626,9 @@
                   log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * previous_upt_event  : %d",previous_upt_event);
                   log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * previous_ufpt_event : %d",previous_ufpt_event);
-
+                  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_UPT_UPDATE      : %d",reg_UPT_UPDATE [context]);
+                          
                   // Have a miss !!!
                   // Flush UPFT
-                  flush_UFPT [context] = not previous_ufpt_event;
+                  flush_UFPT [context] |= not previous_ufpt_event;
                   
                   if (reg_UPDATE_PREDICTION_TABLE [context][depth]._state == UPDATE_PREDICTION_STATE_WAIT_END)
@@ -587,5 +646,5 @@
                       reg_UPT_TOP       [context] = depth;
 //                    reg_UPT_TOP_EVENT [context] = top;
-
+                      
                       if (not previous_upt_event)
                         {
@@ -604,4 +663,5 @@
                                 // Have already update predictor
                                 reg_UPDATE_PREDICTION_TABLE [context][top]._state = UPDATE_PREDICTION_STATE_END;
+                                reg_UPT_UPDATE              [context] = new_update;
                                 break;
                               }
@@ -649,8 +709,9 @@
                           }
                         }
-                      reg_EVENT_SOURCE          [context] = EVENT_SOURCE_UPT;
+//                       reg_EVENT_SOURCE          [context] = EVENT_SOURCE_UPT;
                       
                       // else no update
                       
+                      reg_EVENT_IS_BRANCH       [context] = true;
                       reg_EVENT_DEPTH           [context] = depth;
                       reg_EVENT_ADDRESS_SRC     [context] = address_src; // delay_slot is compute in Context_State
@@ -675,4 +736,6 @@
 		}
 
+              log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_EVENT_STATE     : %s",toString(reg_EVENT_STATE [context]).c_str());
+
 	      // In all case : update good_take
 	      reg_UPDATE_PREDICTION_TABLE [context][depth]._good_take    = good_take;
@@ -686,4 +749,5 @@
                 reg_UPDATE_PREDICTION_TABLE [context][depth]._address_dest = good_addr;
             }
+
 
  	// ===================================================================
@@ -779,67 +843,47 @@
                     
                     // Flush UPT
-                    Tdepth_t depth      = (_param->_have_port_depth)?PORT_READ(in_EVENT_DEPTH [i]):0;
-                    uint32_t top        = reg_UPT_TOP    [i];
-                    uint32_t bottom     = reg_UPT_BOTTOM [i];
-                    uint32_t new_update = ((top==0)?_param->_size_upt_queue[i]:top)-1; 
-//                     bool     empty      = reg_UPT_EMPTY [i];
-
+                    uint32_t bottom = reg_UPT_BOTTOM [i];
+
+                    log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * bottom     : %d",bottom);
+
+//                     event_state_t event_state         = reg_EVENT_STATE [i];
+//                     bool          previous_update_ras = ((event_state == EVENT_STATE_MISS_FLUSH_UFPT_AND_UPT ) or
+//                                                          (event_state == EVENT_STATE_MISS_FLUSH_UPT          ) or
+//                                                          (event_state == EVENT_STATE_EVENT_FLUSH_UFPT_AND_UPT) or
+//                                                          (event_state == EVENT_STATE_EVENT_FLUSH_UPT));
+
+                    bool     find   = false; // have slot to update ???
+                    Tdepth_t top    = bottom;
+                    Tdepth_t update = bottom;
+                    bool     empty  = reg_UPT_EMPTY [i];
+
+                    // flush all slot, because this event is in head of rob
+                    for (uint32_t j=0; j<_param->_size_upt_queue[i]; ++j)
+                      {
+                        Tdepth_t x = (bottom+j)%_param->_size_upt_queue[i];
+                        
+                        if ((reg_UPDATE_PREDICTION_TABLE [i][x]._state != UPDATE_PREDICTION_STATE_END) and
+                            (reg_UPDATE_PREDICTION_TABLE [i][x]._state != UPDATE_PREDICTION_STATE_EMPTY))
+                          {
+                            find = true; // find a not empty slot
+                            reg_UPDATE_PREDICTION_TABLE [i][x]._state = UPDATE_PREDICTION_STATE_EVENT;
+                            reg_UPDATE_PREDICTION_TABLE [i][x]._retire_ok = false;
+                            update = x;
+                          }
+
+                        if (reg_UPDATE_PREDICTION_TABLE [i][x]._state != UPDATE_PREDICTION_STATE_EMPTY)
+                          top = x+1;
+                      }
+
+                    top = top%_param->_size_upt_queue[i];
+
+                    log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * find       : %d",find);
                     log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * top        : %d",top);
-                    log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * depth      : %d",depth);
-                    log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * new_update : %d",new_update);
-
-                    event_state_t event_state         = reg_EVENT_STATE [i];
-                    bool          previous_update_ras = ((event_state == EVENT_STATE_MISS_FLUSH_UFPT_AND_UPT ) or
-                                                         (event_state == EVENT_STATE_MISS_FLUSH_UPT          ) or
-                                                         (event_state == EVENT_STATE_EVENT_FLUSH_UFPT_AND_UPT) or
-                                                         (event_state == EVENT_STATE_EVENT_FLUSH_UPT));
-
-                    bool     find = false; // have slot to update ???
-                    Tdepth_t depth_new = depth;
-
-                    // flush all slot after the event
-                    for (uint32_t j=(depth+1)%_param->_size_upt_queue[i];
-                         j!=top; 
-                         j=(j+1)%_param->_size_upt_queue[i])
-                      if ((reg_UPDATE_PREDICTION_TABLE [i][j]._state != UPDATE_PREDICTION_STATE_END) and
-                          (reg_UPDATE_PREDICTION_TABLE [i][j]._state != UPDATE_PREDICTION_STATE_EMPTY))
-                        {
-                          find = true;
-                          reg_UPDATE_PREDICTION_TABLE [i][j]._state = UPDATE_PREDICTION_STATE_EVENT;
-                          reg_UPDATE_PREDICTION_TABLE [i][j]._retire_ok = false;
-                        }
-                      else
-                        if (not find) // while state == end or empty
-                          depth_new ++;
-                    
-                    if ((reg_UPDATE_PREDICTION_TABLE [i][depth]._state != UPDATE_PREDICTION_STATE_END) and
-                        (reg_UPDATE_PREDICTION_TABLE [i][depth]._state != UPDATE_PREDICTION_STATE_EMPTY))
-                      {
-                        find = true;
-                        reg_UPDATE_PREDICTION_TABLE [i][depth]._state = UPDATE_PREDICTION_STATE_EVENT;
-                        reg_UPDATE_PREDICTION_TABLE [i][depth]._retire_ok = false;
-
-                      }
-                    else
-                      // while state == end or empty
-                      depth = (depth_new+1)%_param->_size_upt_queue[i];
-
-                    log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * find       : %d",find);
-                    log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * depth_new  : %d",depth_new);
                     
                     // Test if have update slot
                     if (find)
                       {
-//                         // flush all slot after the event
-//                         for (uint32_t j=(depth+1)%_param->_size_upt_queue[i];
-//                              j!=top; 
-//                              j=(j+1)%_param->_size_upt_queue[i])
-//                           reg_UPDATE_PREDICTION_TABLE [i][j]._state = UPDATE_PREDICTION_STATE_EVENT;
-
-//                         reg_UPDATE_PREDICTION_TABLE [i][depth]._state = UPDATE_PREDICTION_STATE_EVENT;
-                        
-                        // reg_UPT_BOTTOM    [i];
                         // TODO : special case : event is an exception on branch, also depth is not valid
-                        reg_UPT_TOP       [i] = depth; // depth is again valid
+                        reg_UPT_TOP       [i] = top; // depth is again valid
                         reg_UPT_TOP_EVENT [i] = top;
                         
@@ -847,12 +891,5 @@
                           reg_UPT_EMPTY [i] = true;
                       }
-
-                    bool     full       = ((depth == top) and (top == bottom) and not reg_UPT_EMPTY [i]);
-                    bool     update_ras = find and ((top != depth) or full);
-                    
-                    log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * update_ras : %d",update_ras);
-                    
-                    if (not previous_update_ras and update_ras)
-                      reg_UPT_UPDATE [i]  = new_update;
+                    reg_UPT_UPDATE [i]  = update;
               
                     // new state :
@@ -862,20 +899,36 @@
                     //            * ok : nothing
                     //            * ko : flush upt
-                    reg_EVENT_VAL     [i] = true;
-                    reg_EVENT_UPT_PTR [i] = depth;
-
+                    reg_EVENT_VAL             [i] = find;
+                    reg_EVENT_IS_BRANCH       [i] = false;
+                    reg_EVENT_UPT_PTR         [i] = top;
+                    reg_EVENT_UPT_FULL        [i] = (not empty and (bottom == reg_UPT_TOP [i]));
+                    reg_EVENT_DEPTH           [i] = top;
+//                  reg_EVENT_ADDRESS_SRC     [i] = address_src; // delay_slot is compute in I_State
+//                  reg_EVENT_ADDRESS_DEST_VAL[i] = good_take;
+//                  reg_EVENT_ADDRESS_DEST    [i] = good_addr;
+
+                    log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_UPT_BOTTOM                   : %d",reg_UPT_BOTTOM          [i]);
+                    log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_UPT_TOP                      : %d",reg_UPT_TOP             [i]);
+                    log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_UPT_EMPTY                    : %d",reg_UPT_EMPTY           [i]);
+
+                    log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_EVENT_VAL                    : %d",reg_EVENT_VAL           [i]);
+                    log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_EVENT_UPT_PTR                : %d",reg_EVENT_UPT_PTR       [i]);
+                    log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_EVENT_UPT_FULL               : %d",reg_EVENT_UPT_FULL      [i]);
                     log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_UFPT_NB_NEED_UPDATE          : %d",reg_UFPT_NB_NEED_UPDATE [i]);
-//                     if (reg_UFPT_NB_NEED_UPDATE [i] > 0)
+                    log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_UFPT_NB_UPDATE               : %d",reg_UFPT_NB_UPDATE      [i]);
+
                     if ( (reg_UFPT_NB_NEED_UPDATE [i] > 0) or
                          (reg_UFPT_NB_UPDATE      [i] > 0))
                       {
-                        if (update_ras)
+                        if (find)
                           {
-                            log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * EVENT [%d] <- EVENT_STATE_EVENT_FLUSH_UFPT_AND_UPT (branch_complete - miss)",i);
+                            log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * EVENT [%d] <- EVENT_STATE_EVENT_FLUSH_UFPT_AND_UPT (event - find)",i);
                             reg_EVENT_STATE [i] = EVENT_STATE_EVENT_FLUSH_UFPT_AND_UPT;
                           }
                         else
                           {
-                            log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * EVENT [%d] <- EVENT_STATE_EVENT_FLUSH_UFPT (branch_complete - miss)",i);
+                            log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * EVENT [%d] <- EVENT_STATE_EVENT_FLUSH_UFPT (event - not find)",i);
+//                          reg_EVENT_VAL   [i] = false;
+
                             reg_EVENT_STATE [i] = EVENT_STATE_EVENT_FLUSH_UFPT;
                           }                          
@@ -883,9 +936,8 @@
                     else
                       {
-//                         if (not previous_update_ras)
-                        if (update_ras)
+                        if (find)
                           {
                             // have ras prediction ?
-                            log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * EVENT [%d] <- EVENT_STATE_EVENT_FLUSH_UPT (branch_complete - miss)",i);
+                            log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * EVENT [%d] <- EVENT_STATE_EVENT_FLUSH_UPT (event - find)",i);
                             
                             reg_EVENT_STATE [i] = EVENT_STATE_EVENT_FLUSH_UPT;
@@ -894,5 +946,7 @@
                           {
                             // special case : nothing
-                            reg_EVENT_VAL     [i] = false;
+                            log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * EVENT [%d] <- EVENT_STATE_EVENT_FLUSH_UPT (event - not find)",i);
+
+//                          reg_EVENT_VAL     [i] = false;
 
                             reg_EVENT_STATE [i] = EVENT_STATE_OK;
